\documentclass[a4paper]{article}
\usepackage[noamsthm]{beamerarticle}

\mode<Article>{\usepackage{fullpage}}
\mode<presentation>
{
  \usetheme{Warsaw}
  \setbeamercovered{transparent}
  % or whatever (possibly just delete it)
}


\usepackage[english]{babel}
% or whatever
\usepackage{pgf}
\usepackage{url}
\usepackage{pdfpages}

\usepackage{ucs}
\usepackage[utf8x]{inputenc}
% or whatever

\usepackage{times}
\usepackage[T1]{fontenc}
\usepackage{textcomp}

%for handout mode
\usepackage{pgfpages}
%\pgfpagesuselayout{2 on 1}[a4paper,border shrink=5mm]

%\setbeamertemplate{navigation symbols}{}


\title[The new arm ABI (EABI)] % (optional, use only with long paper titles)
{Debian armel port}

\subtitle[]

\author[Wookey] % (optional, use only with lots of authors)
{Wookey  \\ (Balloonz / Toby Churchill Ltd) \\ \texttt{wookey@wookware.org}}
% - Give the names in the same order as the appear in the paper.
% - Use the \inst{?} command only if the authors have different
%   affiliation.
%\inst[Balloonz]
%{Balloonz / Toby Churchill Ltd}
% - Use the \inst command only if there are several affiliations.
% - Keep it simple, no one is interested in your street address.

\date[Debconf 2007] % (optional, should be abbreviation of conference name)
{Debconf 2007,\\Edinburgh}
% - Either use conference name or its abbreviation.
% - Not really informative to the audience, more for people (including
% yourself) who are reading the slides online

%\pgfdeclareimage[width=2cm]{bohl}{BOHL_Logo_grey}
%\logo{\pgfuseimage{bohl}}

% Delete this, if you do not want the table of contents to pop up at
% the beginning of each subsection:
%\AtBeginSubsection[]
%{
%  \begin{frame}<beamer>
%    \frametitle{Outline}
%    \tableofcontents[currentsection,currentsubsection]
%  \end{frame}
%}

% If you wish to uncover everything in a step-wise fashion, uncomment
% the following command: 
%\beamerdefaultoverlayspecification{<+->}

\begin{document}

%\pgfdeclareimage[width=4cm]{fosdemlogo}{fosdemlogo} 

\begin{frame}[plain]
\logo{\pgfuseimage{fosdemlogo}}
\titlepage
\end{frame}

\begin{frame}
  \tableofcontents
\end{frame}

%%%%%%%%%%%%%%%%%

% user this for stuff which is only in the article:
%  \only<article>{}
%and this for stuff which is only in the presentation
% <presentation:only>e.g. \item<presentation:only> foo in this tiem

\section{Introduction}

\begin{frame}
  \frametitle{Intro}

This paper covers the new arm architecture ABI (EABI), explaining what
it is, what is new and different about it compared to the existing arm
ABI, and why that matters.

It also covers Debian's response to this: the armel architecture, the current 
status of that port, and possible futures for it.

\mode<presentation>
\begin{itemize}[<+->]
	\item Intro
	\item Where did we start from
 	\item What happened
 	\item Lots of gory details so you can understand what I'm on about.
 	\item Why things need to change and where are we now
	\item What Debian is doing about all this
	\end{itemize}

\mode*
\end{frame}


\begin{frame}
  \frametitle{EABI}
  
\mode<article>  
OK, so first let us be clear what we are talking about. The ABI is all
about the \emph{binary} interface, not the programming interface
(API). So we are coving how values are aligned on the stack in a
function call, not what the parameters to that call are.

The main concern of the ABI is the C function calling convention, 
the size and alignment of C types, and FP instructions. Lets deal with
C function calling first. 

An important thing to understand is that every library that is
called by a program must be using the same ABI as the program otherwise
the function calls will probably explode messily. In practice this
means that you cannot mix ABIs on a system. (It is theoretically
possible but you need to be really sure which program is going to call
which library so that library function calls always match up).

The net result of this is that the old ABI is not comptible with the
new EABI so the whole system needs to be using one or the other - this
is an incompatible change. 

Whilst we were breaking everything like like this, it seemed like a
good time to change the kernel syscall mechanism too, and get all the
pain over in one go.

Finally, the E in EABI stnads for `Embedded'. This doesn't really mean
much, except to indicate that arm is generally used in an embedded
context. So far as we are concerned it means `New' - there isn't a
non-embdedded ABI to worry about.

\mode<presentation>
	\begin{itemize}
	\item<presentation:only> What is ABI?
	\item<presentation:only> Not API
	\item<presentation:only> C function calling convention
	\item<presentation:only> All libraries need to match up
  	\item<presentation:only> Kernel syscall convention also changed
	\end{itemize}

\mode*
\end{frame}


\begin{frame}
  \frametitle{History}
  
\mode<article>  
First a bit of historical context. 

The Arm kernel port was done in 1998. It used GCC's C calling
convention for ARM. This was designed to pass 5 or more arguments
efficiently by using registers. This is the same as the RISCOS
conventions, except that it doesn't use the condition codes to
indicate errors/return status.

Floating point was done with the standard FP instruction set of the
time. These are exectued by the FPU if present, or emulated if it is not.

\mode<presentation>

        ARM kernel port created in 1998
	
	Used GCC's C calling convention for ARM
	
User to kernel syscall interface was designed to pass 5 or more arguments
efficiently (via registers).
So similar to RISCOS conventions, but doesn't use condition codes to
indicate errors. 

Floating point was done with FP instruction set. Executed by FPU if present,
emulated if not.
\mode*
\end{frame}


\begin{frame}
  \frametitle{Supported machines}

        Debian-arm port started in 2000
	\begin{itemize}
	\item Netwinder: 2000
	\item RiscPC, Cats: 2001
	\item Lart, Bast: 2003
	\item Iyonix, Manga: 2004
	\item NSLU2, Thecus: 2005/6
	\end{itemize}
        \only<presentation>{Many others without debian-installer
	support}
	\only<article>{There are numerous other machines on which
	Debian-arm is used, but which do not have debian-installer
	support and so are not officially supported machines.}
\end{frame}


\section{EABI changes}

\begin{frame}
  \frametitle{Floating Point}

\only<article>{Unfortunately, in the real world, ARM FPUs have turned
out to be like hen's teeth. There were a couple back in the mid-1990s,
then none for best part of a decade until recent devices, but all
those in fact have different instruction sets from the original ARM FPU.}
\only<presentation>{ARM FPUs have turned out to be like hens teeth}

  \begin{itemize}
   \item CPUs with FPU:
	\begin{itemize}
	\item 	ARM FPA11, VLSI 7500FE
	\end{itemize}

   \item CPUs without FPU:
	\begin{itemize}
	\item 	Cirrus Logic 711x, 720T, 72xx, 73xx
	\item 	Dec/Intel SA110, 1100, 1110
	\item 	Intel PXA250, 255, 270, IXP4xx, ixp2000
	\item 	Samsung chips 
	\item 	Atmel AT91xx
	\ldots
	\end{itemize}

   \item New FPUs with different instruction sets:
	\begin{itemize}
	\item 	Cirrus EP93xx has Maverick crunch
	\item 	Intel IWMMXT 
	\item 	TI Omap 2420 (Arm11 - VFP)
	\item 	Philips lpc3180 (arm9)
	\end{itemize}
      \end{itemize}
\end{frame}



\begin{frame}
  \frametitle{FP solutions}

\only<article>{Because almost all arm systems do not have a real FPU,
various forms of emulation are needed instead. Originally there was
only a binary module from Acorn Computers Ltd, then the equivalent
Netwinder FP Emulator which replaced it with free software, and later
a reduced-accuracy/increased speed version (FastFPE).

The FPU instruction emulation mechanism is very inefficient because
each FP instruction is executed, causing an illegal
instruction abort, which is trapped by the kernel and then delivered
to the emulation module, with the result being returned as if it came
from a real FPU. All of this has hundreds of instructions of overhead
for each emulated instruction.

A much better solution is GCC's softfloat which short-circuits the
trapping/return part of the above and just puts the
instructions which would be executed to actually do the calculations
into the program at compile time. This is much more efficient.}

     \begin{itemize}
	\item 	Runtime Emulators (`hard-float'):
	\begin{itemize}
	    \item Acorn FPE (binary module)
	    \item NWFPE, FastFPE
	\end{itemize}
	\item 	Compile-time functions (`soft-float')
	\begin{itemize}
	    \item GCC softfloat
	\end{itemize}
     \end{itemize}

\only<article>{However the two mechanisms have different calling
conventions and so cannot be mixed in a system - everything has to be
using soft-float or everything has to be using hard-float.}

\only<presentation>{Softfloat and Emulators incompatible due to
different calling conventions.}

Real FPU/emulation: Calls use r0-r3 for 1st 4 arguments, stack for the rest. floats can fill
multiple registers, and be split across registers and stack. 
Return value is put in Coprocessor register f0. 

With softfloat, the return value is put in r0-r2 (depending on size)

Debian-arm uses hard-float, because it pre-dates the soft-float concept.
\end{frame}


\begin{frame}
  \frametitle{FP formats}

\mode<article>
An interesting wrinkle on arm is the format used to represent
doubles. It is big endian within each word, but the two words are
arranged little-endian (on little endian arms). This complies with
IEEE754 on FP formats, but is not used by any other arch and thus can
reasonably be deemed `weird'.


\mode<presentation>
Interesting wrinkle
Mixed endian (on LE arm). IEEE754 but is still rather 'wierd'.

\mode*
Pi in double format looks like this:
\begin{verbatim}
	x86:   18 2d 44 54 fb 21 09 40 (little endian)
	Sparc: 40 09 21 fb 54 44 2d 18 (big endian)
	arm:   fb 21 09 40 18 2d 44 54 (mixed endian)
\end{verbatim}

(Arms running in big-endian mode have big-endian word arrangement as
well as being big-endian within the words, so are the same layout as
other big-endian devices.)

Debian-arm is little-endian, because that was normal when it was
created and in fact most arm CPUs are still run in little-endian mode.

This has caused problems in Mozilla, Perl, Gnumeric, maths libraries
and more: anything that tries to manipulate floats on its own rather than using glibc.

This 'feature' goes away with EABI.
\end{frame}

\begin{frame}
  \frametitle{Why do we care?}

\only<article>{So, what are the pros and cons of this new ABI?}

Pros 

	\begin{itemize}
	\item 	Standardisation across toolchains, debuggers 
	\item 	Most arm wierdness removed (FP formats, packing, C++ exceptions)
	\item 	Hard/soft float interworking (soft-float \emph{much} faster)
	\item 	Thumb interworking
	\item 	Interchangeable binaries (PalmOS, GNU/Linux, Symbian OS)
	\item 	More efficient syscall convention
	\end{itemize}

Cons
	\begin{itemize}
	\item 	Almost total incompatibility with existing port
	\end{itemize}

One feature of the new ABI is that it has been designed to be used
across numerous OSes, so the same code can run on SymbianOS and Linux.
This is really only useful to proprietary code vendors, but is
nevertheless pleasing standardisation, which makes code analysis tools
more widely applicable, as does the use of standards, such as the
DWARF3 debug format.

So there are lots of good reasons why it is technically better, but
the fact that it is incompatible with the last decade of arm work is a
big deal. 

\end{frame}

\begin{frame}
  \frametitle{New kernel syscall convention}

\only<article>{An example is the easiest way to show the differnce
between the legacy ABI and EABI kernel syscall mechanisms:}

Example: long ftruncate64(unsigned int fd, loff\_t length):

	\begin{itemize}
	\item legacy ABI:
	\begin{itemize}
		\item 	- put fd into r0
		\item 	- put length into r1-r2
		\item 	- use ``{\tt swi \#(0x900000 + 194)}'' to call the kernel
	\end{itemize}

	\item EABI:
	\begin{itemize}
		\item 	- put fd into r0
		\item 	- put length into r2-r3 (skipping over r1)
		\item 	- put 194 into r7
		\item 	- use ``{\tt swi 0}'' to call the kernel
	\end{itemize}
	\end{itemize}


Originally ARMs had a von Neumman arch (combined data and instruction
cache) so having the syscall encoded in the SWI instruction made sense
(already in cache, saves store/load).

In a Harvard arch (separate data/instruction cache,as found on modern
arm CPUs) having the syscall number in the SWI instruction is wasteful
(pollutes data cache) and the extra register store/load is much more
efficient.

\end{frame}

\mode<article> The syscall mechanism was changed in kernel 2.6.15, and
reached mainline in 2.6.16. A compatibility mechanism for the
old-style calls is in the kernel so that both EABI and legacy
programs can be run by one kernel.

The speed gain that can be realised by the new mechanism is only
actually realised if the compatibilty mechanism is disabled.

There was a transitional period represented by glibc 2.3.6 and the
2005q3 Codesourcery toolchain which used shims in glibc to allow old
syscalls with new EABI. This was removed in glibc 2.3.7/2.4 and later.


\mode<presentation>
\begin{frame}
  \frametitle{New syscalls (2)}

Changed in kernel 2.6.15 - mainline 2.6.16


Kernels retain old syscall compatibility so they can run older binaries. 
The speed gain is not realised unless this is disabled
The 2005q3 toolchain (and probably others) used old syscall interface via userspace shims in glibc 2.3.6 for use with kernels prior to 2.6.15. 
This was removed in glibc 2.4 and 2.3.7 - no longer supported

\end{frame}
\mode*

\mode<article>
\begin{frame}
 \frametitle{EABI genesis}

The EABI was created by taking existing external standards wherever
possible, merging this with some ARM Corp. internal standards, and a
few things had to be defined specially. 
		\begin{itemize}
		\item external stuff: 
			\begin{itemize}
			\item ELF
			\item DWARF-3
			\item generic C++ ABI
			\end{itemize}
		\item internal stuff:
			\begin{itemize}
			\item Procedure call standard (AAPCS = simplified, clarified ATPCS)
			\item ELF processor supplement
			\item anticipates thumb-2 and arm v6 (new-style BE8)
			\end{itemize}
		\item plus new stuff:
			\begin{itemize}
			\item C++ exception handling, Clibrary, run-time helper functions
			\end{itemize}
		\end{itemize}
\end{frame}


\mode*
\begin{frame}
  \frametitle{Timeline}

	\begin{itemize}
	\item New ABI published Dec 2003\mode<presentation>, based on:

		\begin{itemize}
		\item external stuff: 
			\begin{itemize}
			\item ELF
			\item DWARF-3
			\item generic C++ ABI
			\end{itemize}
		\item internal stuff:
			\begin{itemize}
			\item Procedure call standard (AAPCS = simplified, clarified ATPCS)
			\item ELF processor supplement
			\item anticipates thumb-2 and arm v6 (new-style BE8)
			\end{itemize}
		\item plus new stuff:
			\begin{itemize}
			\item C++ exception handling, Clibrary, run-time helper functions
			\end{itemize}
		\end{itemize}
\mode*
	\item Code sourcery 1st cross-tools q3 2005 GCC v3.4.4
	\item 2005: Early Linux adopters (montavista, nokia) - shimmed glibc
	\item Kernel syscalls changed during 2.6.15 
	\item Debian port started q1 2006 - all new
	\item Aleph One and Code sourcery gcc4.1 cross-tools q1 2006
	\item Angstrom OE EABI Aug 2006 
	\item ADS/Lennert Buytenhek working port Jan 2007 (v4t build)
	\item DD-signed (Riku Voipio) buildd announced April 2007 (v4t build)
	\end{itemize}
\end{frame}


\begin{frame}
  \frametitle{Main EABI changes}

\only<article>{These are the main changes that the EABI causes
relative to the legacy ABI. Primarily alignment/packing is now natural
making arm a more `conventional' architecture.}

	\begin{itemize}
	\item Structure packing
	  \begin{itemize}
		\item Old ABI had min structure packing size of 4 bytes
		\item EABI has no minimum - packing is determined by type sizes 
	  \end{itemize}

	\item Argument alignment
	  \begin{itemize}
		\item 8-byte stack alignment at public function entry points
                    \\(Old ABI was 4-bytes)
		\item 64-bit data types (e.g. long long) are 8-byte aligned
                    \\(Old ABI was 4-bytes)
	  \end{itemize}

	\item Enums
	  \begin{itemize}
		\item EABI allows enums to have variable type size (-mabi=aapcs)
		\item Not used on GNU/Linux - they remain as 4-bytes. (-mabi=aapcs-linux)
	  \end{itemize}

	\item Floating point
	  \begin{itemize}
		\item Mixed-endian LE format goes away
		\item Can mix GCC softfloat and FPU hardfloat/emulation
	  \end{itemize}
	\end{itemize}

\end{frame}

\begin{frame}
  \frametitle{Tools}

\mode<article>

The toolchain work has been done by Codesourcery on behalf of ARM
Corp. EABI support was originally added in gcc3.4.4 with the
-mabi=aapcs-linux option.

From gcc 4.1 the mode was given a new gnu triplet:
linux-arm-gnueabi. The legacy ABI is is linux-arm-gnu. i.e. gcc treats
it as a whole new architecture, which technically, it is. 

Glibc had shims added in 2.3.6 and new syscalls in 2.3.7/2.4. In fact
2.4 has serious shortcomings on arm, so glibc 2.5 is really needed.

Kernel has new syscalls added in 2.6.16

Crosstool from v0.42 has the necessary juju to build working crosstools
with EABI support.

\mode<presentation>
  \begin{itemize}GCC
    \begin{itemize}
	work done by Code Sourcery 
	eabi support originally added to gcc3.4.4 (with -mabi=aapcs-linux)
	From 4.1: different arch
		Old ABI is called linux-arm-none-gnu
		New ABI (EABI) is called linux-arm-none-gnueabi
    \end{itemize}


Glibc 
    \begin{itemize}	shims in 2.3.6
	new syscalls in 2.4 and 2.3.7
    \end{itemize}

Kernel
    \begin{itemize}	support from 2.6.16
    \end{itemize}
  \end{itemize}


\end{frame}

\begin{frame}
  \frametitle{Tools (2)}


All-new style needs:
	\begin{itemize}
	\item 	gcc-4.1, 
	\item 	glibc-2.4+glibc-ports-2.4, (glibc 2.5 much better)
	\item 	binutils-2.16.91.0.7 (or similar) and
	\item 	linux-2.6.16. 
	\item 	This can be compiled using crosstool-0.42
	\end{itemize}
\mode*
\end{frame}

\section{EABI and Debian-arm}

\begin{frame}
  \frametitle{Debian port}

\mode<article>
The debian arm port has been working on incorporating these changes
into Debian. We could just ignore them and carry on with our existing
port, but it is clear that there are significant technical advantages
to changing, and it seems likely that the legacy arm ABI will
eventually become obsolete.

The main advantages are that we get:-
	\begin{itemize} 
		\item Much better FP performance by default (approx 20 times better)
		\item The ability to mix hard-fp and soft-float on the same system
		\item More conventional packing rules so stuff that never built probably will now
	\end{itemize}

There are other less signifcant reasons such as binary compatibility
with other OSes, wider debug tool support, and the aforementioned
avoiding obsolesence.

The main \emph{disadvantage} is the fact that the new port is completely
incompatible with the old one. 

So - How do we make the change? There are a number of possible
approaches.

\mode<presentation>
Worth changing to
	\begin{itemize}
	\item 	Avoid obsolescence 
	\item 	Fix the FP problem
	\item 	Build stuff that never worked
	\end{itemize}

Binary compatibility not a huge issue for free software, but still
convenient. (can use commerical debuggers if you like).

Incompatibility with existing port a problem.


How to make the change?...
\mode*
\end{frame}

\begin{frame}
  \frametitle{Rename all library packages}


Pros
	\begin{itemize}
	\item 	Can do apt-get dist-upgrade
	\end{itemize}

Cons
	\begin{itemize}
	\item 	Every single library package needs to be renamed
	\item 	Will take a long time, during which unstable will be
	broken for all arches (6months for C++, so 2yrs?)
	\item 	Not popular due to large hassle for other arches
	\item 	Will lose v3, may lose v4 support.
	\end{itemize}

\end{frame}


\begin{frame}
  \frametitle{New architecture}

Pros
	\begin{itemize}
	\item 	Fits with gcc approach
	\item 	Does not affect non-arm arches
	\item 	Can keep 'arm' for v3 and maybe v4 machines
	\item 	Can be done relatively quickly as no interaction with other arches/releases
	\end{itemize}

Cons
	\begin{itemize}
	\item 	Current arm users don't have easy upgrade path 
	\item 	Need archive space for new arch
	\end{itemize}

\end{frame}

\begin{frame}
  \frametitle{ABI: field in control file}

Suggested as part of multiarch proposal

Pros
	\begin{itemize}
	\item 	Reflects ABI correctly, would help other transitions too
	\end{itemize}

Cons
	\begin{itemize}
	\item 	No existing implementation
	\item 	No consensus on including it yet
	\item 	Questions over resolving dependencies and how it fits into archive
	\end{itemize}

\end{frame}

\begin{frame}
  \frametitle{Conflicting libc packages}


Make a libc6-eabi-dev depending on eabi and ld-linux.so.3, that conflicts with libc6. 

Pros
	\begin{itemize}
	\item 	Only have to change glibc (and rebuild everything)
	\item 	Does not affect other arches
	\end{itemize}

Cons
	\begin{itemize}
	\item 	Most of port will be uninstallable for a very long time
	\item 	apt-get dist-upgrade still won't work due to huge number of conflicts
	\item 	Will lose v3, may lose v4 support
	\end{itemize}

\end{frame}

\begin{frame}
  \frametitle{`New Arch' won }

Largely because it could be done in an independent manner (not
affecting the existing arm port, or the rest of Debian), and matched
the toolchain view, the arm porters decided that a new architecture was
the best way to go.

There was some debate what to call it; as the best name `arm' had
already been taken by the existing port. Mailing list discussion
failed to acheive consensus, so when we had most of the people
involved at the Embedded Debian work session in Extramadura in April
2005 we thrashed it out and decided to go with ``armel'',
following the nomenclature arm themelves use for naming cpu types.

This allows for a corresponding `armeb' big-endian port, although
there was already an unoffical one called that which was using the
legacy ABI, so whilst it is OK for Debian, there is an issue for
existing users changing over. 

\mode<presentation>
`New architecture' won.

called armel

could also have armeb
\mode*
\end{frame}

\begin{frame}
  \frametitle{CPU choice}

\only<article>{The next significant issue is which CPUs to support
with which port. This is a summary of the instruction set versions,
and which machines use them.}

	\begin{itemize}
	\item 	v3 (RiscPC)
	\item 	v4 (Strongarm)
	\item 	v4t (most arm 7)
	\item 	v5 (xscale, arm9, 10, 11)
	\item 	v6 coming soon - new BE8 mode
	\end{itemize}

\only<article>{So all current arm CPUs are v4t or v5.}

\only<presentation>{Thumb interworking (BX, LDM, etc)}

\only<presentation>{GCC versions: 4.1.0 broken for v4t}

\end{frame}

\begin{frame}
  \frametitle{Thumb interworking}


\mode<article>
The big issue here is thumb interworking. Thumb is ARMs reduced-space
instruction set. It has 16-bit instructions, rather than the standard
32-bit instructions, generally resulting in a 30\% space saving. 

The EABI provides for the facility to swap back and forth between
thumb code on every function-call boundary. However to do this (on
v4t) it uses the BX instruction to set the core to the correct state
on call and return. This instruction is not present prior to v4t. This
means that code built for EABI does not run on v4 processors. 

Currently all debian's arm buildds are v4 machines (CATS, Netwinder).
Although new build machines are likely to be installed soon as these
are slow, and certainly the armel port will be using newer hardware.
Nevertheless the machines are still reasonably well-used and it is not
clear at what point support could/should be dropped. v3 machines such
as RISCOS we can definately give up on at this stage - the remaining
userbase is tiny.

Thumb is not actually used at all in Debian, and may not be in the
future. We could simply drop the interworking support in order to be
v4 compatible, but that would mean breaking the ABI rules, and it
seems like a bad idea to remove the possibility of using thumb in
Debian at all if we can help it.

It is fairly simple to modify the function call code so that it works
with v4, by having a test for thumb capability to skip the BX:
\mode<presentation>
	Thumb is 16-bit opcode set (normal opcodes are 32-bit)
	Reduced code size (30% smaller) - popular with mobile phone people
	EABI allows mixing at function level granularity
	Needs ARM v4t due to use of BX instruction to set correct state
	On arm v5 LDR/LDM does this
	v4 doesn't have BX. StrongARM is v4. Will abort.
		Need to use this instead:  
\mode*
\begin{verbatim}
                tst lr, \#1
                moveq pc, lr
                bx lr 
\end{verbatim}

\mode<article>
However this is an extra couple of instructions of overhead on every
function call. 

A patch to support this now exists, but the speed differential has not
yet been tested.

\mode<presentation>
        which is slower.

	Patch to gcc to support this now exists.
	
	Question whether to support v4 (strongarm) with armel, or start at v4t
	If speed/size overhead is not large then we probably should.

It would be nice if v4 machines could be supported
in armel as then the existing arm port need not be maintined for long.
If we need to keep legacy-arm around to support v4 then it could be
here for some time, with all the corresponding overhead in buildds,
archive space and porter work that that implies.
\mode*
\end{frame}

\begin{frame}
  \frametitle{Remaining Issues}
  
\mode<article>
The port is now working and useable, with about half the archive
  built at the time of writing (may 2007). Bugs and issues are being worked through.
  
  We need to have enough buildds, and get them added to the buildd
  monitoring infrastructure so that people can find and fix problems
  easily.
  
  Then clearly the target is to get enough packages built to be
  eligible for official port status. The ARM team intends armel to be
  a lenny release architecture.
  
  A decision needs to be taken on supporting v4 or not in armel, and if
  it is to rebuilt stuff already built for v4t. This is currently
  waiting on toolchain testing.
  
  Related is the issue of how long to support the legacy arm port -
  With v4 in armel is could be ditched after Lenny. (i.e lenny is the
  only release containing both arm and armel). If armel only supports
  v4t or higher then we may need to support arm and armel for longer
  in order to have something that v4 machines can run (how long before
  all the strongarm machines are dead? - they are just about ceasing to
  be sold around now).

  Thanx for reading this far. See http://wiki.debian.org/ArmEabiPort
  for mode complete info.
\mode*
\end{frame}
\end{document}

